#!/usr/bin/env python
# -*- coding: UTF-8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
# Python module plugins/comment/comment.py
# Autogenerated from comment.glade
# Generated on Tue Sep 27 22:11:22 2005

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

import os

import gtk

from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

app_name = "plugin"
app_version = "0.0.1"

glade_dir = ""
locale_dir = "po"

bindtextdomain(app_name, locale_dir)


class Wincomment(SimpleGladeApp):

    def __init__(self, path="comment.glade",
                 root="winComment",
                 domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- Wincomment.new {
    def new(self):

        #############################################################
        ## IN in self.nodes:
        ##  - a list of PhotoNodes()
        ##
        ##
        ## OUT in self.reponse:
        ##  - boolean False : operation abandonned
        ##  - string : one comment for all the pictures
        ##  - [string,] : multi comments
        #############################################################
        self.main_widget.set_modal(True)
        self.main_widget.set_keep_above(True)
        self.main_widget.set_position(gtk.WIN_POS_CENTER)

        self.list=[]
        for i in self.nodes:
            b = gtk.TextBuffer()
            b.set_text(i.comment)
            self.list.append( (i,b) )

        self.lbl_all.set_text(_("%d photo(s)") % len(self.list))
        if len(self.nodes)==1:
            self.tv_all_comment.get_buffer().set_text(self.nodes[0].comment)
            self.notebook1.remove_page(1)
            self.tv_all_comment.grab_focus()
        else:
            self.hscrollbar1.set_range(0,len(self.list)-1)
            self.hscrollbar1.set_increments(1,1)
            self.setPhoto(0)

    #-- Wincomment.new }

    #-- Wincomment custom methods {
    def setPhoto(self,i):
        info = self.list[i]
        node = info[0]
        self.lbl_one.set_text( _("Photo %d/%d : %s ") % (i+1,len(self.list),node.name) )
        self.image1.set_from_pixbuf( node.getThumb() )
        self.tv_comment.set_buffer( info[1] )
    def getTextFromBuffer(self,b):
        start=b.get_start_iter()
        end =b.get_end_iter()
        txt= b.get_text(start,end,False)
        txt = txt.replace("\r","")
        txt= txt.strip()
        return txt.decode("utf_8")

    #-- Wincomment custom methods }

    #-- Wincomment.on_winComment_delete_event {
    def on_winComment_delete_event(self, widget, *args):
        self.reponse=False
        self.main_widget.destroy()
        gtk.main_quit()
    #-- Wincomment.on_winComment_delete_event }

    #-- Wincomment.on_notebook1_switch_page {
    def on_notebook1_switch_page(self, widget, *args):
        gpoint,page= args
        if page==0:
            self.tv_all_comment.grab_focus()
        else:
            self.tv_comment.grab_focus()
    #-- Wincomment.on_notebook1_switch_page }

    #-- Wincomment.on_hscrollbar1_value_changed {
    def on_hscrollbar1_value_changed(self, widget, *args):
        sel = int(widget.get_value())
        self.setPhoto(sel)
    #-- Wincomment.on_hscrollbar1_value_changed }

    #-- Wincomment.on_tv_comment_key_press_event {
    def on_tv_comment_key_press_event(self, widget, *args):
        event=args[0]
        if event.get_state() & gtk.gdk.CONTROL_MASK:
            if event.keyval == 65365:
                self.hscrollbar1.set_value( self.hscrollbar1.get_value()-1 )
            elif event.keyval in [65366,65293]:
                self.hscrollbar1.set_value( self.hscrollbar1.get_value()+1 )
            elif event.keyval == 65360: # HOME
                self.hscrollbar1.set_value(0)
            elif event.keyval == 65367: # END
                self.hscrollbar1.set_value(len(self.list)-1)
            return True # don't do the key !

    #-- Wincomment.on_tv_comment_key_press_event }

    #-- Wincomment.on_btn_annuler_clicked {
    def on_btn_annuler_clicked(self, widget, *args):
        self.reponse=False
        self.main_widget.destroy()
        gtk.main_quit()

    #-- Wincomment.on_btn_annuler_clicked }

    #-- Wincomment.on_btn_ok_clicked {
    def on_btn_ok_clicked(self, widget, *args):
        selectedTab = self.notebook1.get_current_page()
        if selectedTab==0:
            # comment all
            self.reponse=self.getTextFromBuffer( self.tv_all_comment.get_buffer() )
        else:
            # comment one by one
            self.reponse=[self.getTextFromBuffer( b ) for n,b in self.list]
        self.main_widget.destroy()
        gtk.main_quit()

    #-- Wincomment.on_btn_ok_clicked }


#-- main {

def main():
    win_comment = Wincomment()

    win_comment.run()

if __name__ == "__main__":
    main()

#-- main }
