#!/usr/bin/env python
# -*- coding: UTF-8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
# Python module winflickr.py
# Autogenerated from winflickr.glade
# Generated on Tue Sep 20 20:24:08 2005

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

import os

import gtk

from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

app_name = "plugin"
app_version = "0.0.1"

glade_dir = ""
locale_dir = "po"

bindtextdomain(app_name, locale_dir)


class Winflickr(SimpleGladeApp):

    def __init__(self, path="winflickr.glade",
                 root="WinFlickr",
                 domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- Winflickr.new {
    def new(self):
        self.main_widget.set_modal(True)
        self.main_widget.set_keep_above(True)
        self.main_widget.set_position(gtk.WIN_POS_CENTER)


        # prepare the display of the combo
        cell = gtk.CellRendererText()
        self.cb_privacy.pack_start(cell, True)
        self.cb_privacy.add_attribute(cell, 'text',0)

        # get the default params
        email,password,privacy = Winflickr.params

        self.e_email.set_text(email)
        self.e_password.set_text(password)
        self.setList([_("public"),_("friend"),_("family")],privacy)


    #-- Winflickr.new }

    #-- Winflickr custom methods {
    def setList(self,list,n):
        m=gtk.ListStore( str)
        m.clear()
        for i in list:
            m.append( [i,] )
        self.cb_privacy.set_model(m)

        self.cb_privacy.set_active(n)
    #-- Winflickr custom methods }

    #-- Winflickr.on_WinFlickr_delete_event {
    def on_WinFlickr_delete_event(self, widget, *args):
        self.response=False
        self.main_widget.destroy()
        gtk.main_quit()
    #-- Winflickr.on_WinFlickr_delete_event }

    #-- Winflickr.on_btn_cancel_clicked {
    def on_btn_cancel_clicked(self, widget, *args):
        self.response=False
        self.main_widget.destroy()
        gtk.main_quit()
    #-- Winflickr.on_btn_cancel_clicked }

    #-- Winflickr.on_btn_valid_clicked {
    def on_btn_valid_clicked(self, widget, *args):
        self.response= (
                        self.e_email.get_text(),
                        self.e_password.get_text(),
                        self.cb_privacy.get_active(),
                      )
        self.main_widget.destroy()
        gtk.main_quit()
    #-- Winflickr.on_btn_valid_clicked }


#-- main {

def main():
    Winflickr.params=("marco","toto",0)

    win_flickr = Winflickr()
    win_flickr.run()

    print win_flickr.response

if __name__ == "__main__":
    main()

#-- main }
